Bug 1691315 - microdnf fails to install from repo which uses xml:base on location
Summary: microdnf fails to install from repo which uses xml:base on location
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 8
Classification: Red Hat
Component: microdnf
Version: ---
Hardware: Unspecified
OS: Unspecified
high
unspecified
Target Milestone: rc
: 8.0
Assignee: amatej
QA Contact: Jan Blazek
URL:
Whiteboard:
Depends On: 1681091
Blocks: 1734350
TreeView+ depends on / blocked
 
Reported: 2019-03-21 11:45 UTC by Jan Pazdziora
Modified: 2020-11-14 09:26 UTC (History)
7 users (show)

Fixed In Version: libdnf-0.33.0-1.el8
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1734350 (view as bug list)
Environment:
Last Closed: 2019-11-05 22:21:40 UTC
Type: Bug
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:3583 None None None 2019-11-05 22:21:55 UTC

Description Jan Pazdziora 2019-03-21 11:45:59 UTC
Description of problem:

When xml:base is used on location element in primary.xml, microdnf fails to resolve that and find the rpm.

Version-Release number of selected component (if applicable):

microdnf-3.0.1-1.el8.x86_64
libdnf-0.22.5-4.el8.x86_64

How reproducible:

Deterministic.

Steps to Reproduce:
1. yum clean all
2. yum --downloadonly install mutt
3. mkdir /tmp/repo-base
4. find /var/cache/dnf -name '*.rpm' | xargs cp -t /tmp/repo-base
5. mkdir /tmp/repo
6. createrepo_c -u file://$(pwd)/tmp/repo-base tmp/repo-base -o tmp/repo
7. mv /etc/yum.repos.d /etc/yum.repos.d-backup
8. mkdir /etc/yum.repos.d
9. create /etc/yum.repos.d/test.repo with content

[test]
name=Test
baseurl=file:///tmp/repo
gpgcheck=0

10. microdnf install mutt

Actual results:

# microdnf install mutt
Package                                                 Repository          Size
Installing:                                                                     
 mailcap-2.1.48-3.el8.noarch                            test             39.7 kB
 mutt-5:1.10.1-1.el8.x86_64                             test              1.6 MB
 perl-Carp-1.42-396.el8.noarch                          test             30.9 kB
 perl-Errno-1.28-416.el8.x86_64                         test             77.5 kB
 perl-Exporter-5.72-396.el8.noarch                      test             34.8 kB
 perl-File-Path-2.15-2.el8.noarch                       test             39.0 kB
 perl-File-Temp-0.230.600-1.el8.noarch                  test             64.1 kB
 perl-IO-1.38-416.el8.x86_64                            test            144.8 kB
 perl-PathTools-3.74-1.el8.x86_64                       test             92.2 kB
 perl-Scalar-List-Utils-3:1.49-2.el8.x86_64             test             69.4 kB
 perl-Socket-4:2.027-2.el8.x86_64                       test             60.1 kB
 perl-Text-Tabs+Wrap-2013.0523-395.el8.noarch           test             24.7 kB
 perl-Time-Local-1:1.280-1.el8.noarch                   test             34.3 kB
 perl-Unicode-Normalize-1.25-396.el8.x86_64             test             83.8 kB
 perl-constant-1.33-396.el8.noarch                      test             26.0 kB
 perl-interpreter-4:5.26.3-416.el8.x86_64               test              6.6 MB
 perl-libs-4:5.26.3-416.el8.x86_64                      test              1.6 MB
 perl-macros-4:5.26.3-416.el8.x86_64                    test             73.4 kB
 perl-parent-1:0.237-1.el8.noarch                       test             20.5 kB
 perl-threads-1:2.21-2.el8.x86_64                       test             62.7 kB
 perl-threads-shared-1.58-2.el8.x86_64                  test             48.8 kB
 tokyocabinet-1.4.48-10.el8.x86_64                      test            497.5 kB
 urlview-0.9-23.20131022git08767a.el8.x86_64            test             35.0 kB
Transaction Summary:
 Installing:       23 packages
 Reinstalling:      0 packages
 Upgrading:         0 packages
 Removing:          0 packages
 Downgrading:       0 packages
error: File missing in local repository /tmp/repo/mailcap-2.1.48-3.el8.noarch.rpm

Expected results:

# microdnf install mutt
Package                                                 Repository          Size
Installing:                                                                     
 mailcap-2.1.48-3.el8.noarch                            test             39.7 kB
 mutt-5:1.10.1-1.el8.x86_64                             test              1.6 MB
 perl-Carp-1.42-396.el8.noarch                          test             30.9 kB
 perl-Errno-1.28-416.el8.x86_64                         test             77.5 kB
 perl-Exporter-5.72-396.el8.noarch                      test             34.8 kB
 perl-File-Path-2.15-2.el8.noarch                       test             39.0 kB
 perl-File-Temp-0.230.600-1.el8.noarch                  test             64.1 kB
 perl-IO-1.38-416.el8.x86_64                            test            144.8 kB
 perl-PathTools-3.74-1.el8.x86_64                       test             92.2 kB
 perl-Scalar-List-Utils-3:1.49-2.el8.x86_64             test             69.4 kB
 perl-Socket-4:2.027-2.el8.x86_64                       test             60.1 kB
 perl-Text-Tabs+Wrap-2013.0523-395.el8.noarch           test             24.7 kB
 perl-Time-Local-1:1.280-1.el8.noarch                   test             34.3 kB
 perl-Unicode-Normalize-1.25-396.el8.x86_64             test             83.8 kB
 perl-constant-1.33-396.el8.noarch                      test             26.0 kB
 perl-interpreter-4:5.26.3-416.el8.x86_64               test              6.6 MB
 perl-libs-4:5.26.3-416.el8.x86_64                      test              1.6 MB
 perl-macros-4:5.26.3-416.el8.x86_64                    test             73.4 kB
 perl-parent-1:0.237-1.el8.noarch                       test             20.5 kB
 perl-threads-1:2.21-2.el8.x86_64                       test             62.7 kB
 perl-threads-shared-1.58-2.el8.x86_64                  test             48.8 kB
 tokyocabinet-1.4.48-10.el8.x86_64                      test            497.5 kB
 urlview-0.9-23.20131022git08767a.el8.x86_64            test             35.0 kB
Transaction Summary:
 Installing:       23 packages
 Reinstalling:      0 packages
 Upgrading:         0 packages
 Removing:          0 packages
 Downgrading:       0 packages
Running transaction test...
Installing: perl-Exporter;5.72-396.el8;noarch;test
Installing: perl-libs;4:5.26.3-416.el8;x86_64;test
Installing: perl-Carp;1.42-396.el8;noarch;test
Installing: perl-Scalar-List-Utils;3:1.49-2.el8;x86_64;test
Installing: perl-parent;1:0.237-1.el8;noarch;test
Installing: perl-macros;4:5.26.3-416.el8;x86_64;test
Installing: perl-Errno;1.28-416.el8;x86_64;test
Installing: (null)
Installing: perl-Socket;4:2.027-2.el8;x86_64;test
Installing: (null)
Installing: perl-Text-Tabs+Wrap;2013.0523-395.el8;noarch;test
Installing: (null)
Installing: perl-Unicode-Normalize;1.25-396.el8;x86_64;test
Installing: (null)
Installing: perl-File-Path;2.15-2.el8;noarch;test
Installing: (null)
Installing: perl-IO;1.38-416.el8;x86_64;test
Installing: perl-PathTools;3.74-1.el8;x86_64;test
Installing: (null)
Installing: perl-constant;1.33-396.el8;noarch;test
Installing: (null)
Installing: perl-threads;1:2.21-2.el8;x86_64;test
Installing: (null)
Installing: perl-threads-shared;1.58-2.el8;x86_64;test
Installing: (null)
Installing: perl-interpreter;4:5.26.3-416.el8;x86_64;test
Installing: (null)
Installing: perl-File-Temp;0.230.600-1.el8;noarch;test
Installing: (null)
Installing: perl-Time-Local;1:1.280-1.el8;noarch;test
Installing: (null)
Installing: urlview;0.9-23.20131022git08767a.el8;x86_64;test
Installing: (null)
Installing: tokyocabinet;1.4.48-10.el8;x86_64;test
Installing: (null)
Installing: mailcap;2.1.48-3.el8;noarch;test
Installing: (null)
Installing: mutt;5:1.10.1-1.el8;x86_64;test
Installing: (null)
Installing: (null)
Complete.

Additional info:

The dnf command from dnf-4.0.9.2-5.el8.noarch processes such repository with xml:base just fine.

The expected microdnf output happens after I do cp /tmp/repo-base/* /tmp/repo.

Comment 1 amatej 2019-04-01 09:27:20 UTC
I created PR for this: https://github.com/rpm-software-management/libdnf/pull/708

Comment 8 errata-xmlrpc 2019-11-05 22:21:40 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2019:3583


Note You need to log in before you can comment on or make changes to this bug.